MODULE SUIZIDER;

IMPORT IO,BMP,Pantalla,Constant,GRAFIC,avion,MENU,RETARDO,enemy,Lib,Graph;

VAR (*Variables globales*)
  dificultad:CARDINAL;
  havion:avion.TAvion;
  posx,posy:CARDINAL; (*Amparo*)
  pantalla:Pantalla.TPantalla;
  mul:REAL; (*Multiplicador del retardo del caos y del metal*)
  enemigos:enemy.Tenemy;
  luna,gameover,youwin:BMP.TBMP;
  pag:CARDINAL;
  color:LONGCARD;
  POWER:CARDINAL;
  TIEMPO:CARDINAL;
  RETARDODEBUG:CARDINAL;

PROCEDURE Inicializar();
  VAR
    control:INTEGER;

BEGIN
    color:=Graph.SetBkColor(1);
    TIEMPO:=Constant.TIEMPO;
    pag:=0; (*Inicializamos la pagina grafica*)
    dificultad:=Constant.DIFICULTADINICIAL;
    mul:=RETARDO.F_Ret();
    Lib.RANDOMIZE; (*Inicializamos el randomizador*)
    Pantalla.InicializaPantalla(pantalla); (*Inicializamos la pantalla*)
    control:=enemy.Inicializar(enemigos);
    control:=BMP.Inicializa(luna);
    (*control:=BMP.CargaArchivo(luna,Constant.LUNADIB);*)
    control:=BMP.Inicializa(youwin);
    (*control:=BMP.CargaArchivo(youwin,Constant.YOUWIN);*)
    control:=BMP.Inicializa(gameover);
    (*control:=BMP.CargaArchivo(gameover,Constant.GAMEOVER);*)

    IF control<>0 THEN
       IO.WrStr("Error de asignacion de memoria!!!!!!!!!!");
    END;
END Inicializar;




PROCEDURE CreaBichoRandom(VAR enemigos:enemy.Tenemy;VAR pantalla:Pantalla.TPantalla);

 VAR
   temp,temp2,temp3:CARDINAL;
   control:INTEGER;
   c:CHAR;

 BEGIN
     Lib.RANDOMIZE;
     temp:=Lib.RANDOM(Constant.MAXENEMY);
     (*IO.WrStr(" ");
     IO.WrCard(temp,0);*)
     CASE temp OF
          |0:(*Creamos bichos de tipo CAZA*)
             temp:=Lib.RANDOM(Constant.MAXPANTALLAY-70);
             (*IO.WrStr(" CAZA ");
             IO.WrCard(temp,0);*)
             control:=enemy.CrearEnemy(enemigos,pantalla,Constant.CAZA,240,temp+35,-3,0);
          |2:(*Creamos bichos de tipo HARRIER*)
             temp:=Lib.RANDOM(Constant.MAXPANTALLAY-70);
             (*IO.WrStr(" HARRIER ");
             IO.WrCard(temp,0);*)
             control:=enemy.CrearEnemy(enemigos,pantalla,Constant.HARRIER,240,temp+35,-3,3);
             (*IO.WrInt(control,0);
             c:=IO.RdKey();*)
          |3:(*Creamos bichos de tipo MORLOCK*)
             temp:=Lib.RANDOM(Constant.MAXPANTALLAY-70);
             (*IO.WrStr(" MORLOCK ");
             IO.WrCard(temp,0);*)
             control:=enemy.CrearEnemy(enemigos,pantalla,Constant.MORLOCK,240,temp+35,-3,3);
     END;

END CreaBichoRandom;




PROCEDURE Suizidar();

VAR
  muehto:BOOLEAN;
  c:CHAR;
  dirx,diry,control:INTEGER;
  CUARTELILLO:CARDINAL;
  KAOS:BOOLEAN;
  temp:Graph.TextCoords;


BEGIN

    CUARTELILLO:=Constant.CUARTELILLO;
    muehto:=FALSE; (*Porque si no empezamos mal, los cadaveres no pilotan*)
    KAOS:=FALSE;
    control:=avion.Crear(havion); (*Inicializamos el avion maravilloso*)
    avion.InsertaPower(havion,Constant.VIDAAVION);
    IO.RdLn;
    IF control<>0 THEN
       IO.WrStr("MUEHTE, Y KAOZ Y TAL Y KUAL")
    END;


    (*futura generacion aleatoria*)

    (*control:=enemy.CrearEnemy(enemigos,pantalla,Constant.CAZA,280,50,-2,0);
    control:=enemy.CrearEnemy(enemigos,pantalla,Constant.HARRIER,250,100,-3,5);
    control:=enemy.CrearEnemy(enemigos,pantalla,Constant.MORLOCK,250,140,-3,-5);*)

    IF control<>0 THEN
       IO.WrStr("Error de asignacion de memoria!!!!!!!!!!");
    END;
    REPEAT
	
	 GRAFIC.CLS;
	 (*control:=BMP.VisBmpMask(luna,260,10,Constant.MASK); (*Dibujamos la luna*)	*)
	 GRAFIC.DibujaBarra(avion.Power(havion),Constant.VIDAAVION,5,0,190);
	 temp:=Graph.SetTextPosition(25,5);
	 IO.WrStr("VIDA");
	 (*IO.WrCard(avion.Power(havion),0);*)
	 temp:=Graph.SetTextPosition(1,1);
	 IO.WrStr("TIEMPO: ");
	 IO.WrCard(TIEMPO,0);
	

         (*Generacion aleatoria de enemigos*)
         IF (TIEMPO MOD Constant.MULTIPLOGEN=0) AND (enemy.NumEnemies(enemigos) < Constant.MAXNUMENEMIGOSPANT) THEN
            (*IO.WrCard(enemy.NumEnemies(enemigos),0);
            IO.WrStr(" ");*)
            CreaBichoRandom(enemigos,pantalla);
         END;

	 IF muehto THEN
	    control:=BMP.CargaArchivo(gameover,Constant.GAMEOVER);
	    (*Ahhhhh Muehtoooo*)
	    control:=BMP.Destruir(luna);
	    control:=BMP.VisBmpMask(gameover,120,75,Constant.MASK);
	    IF CUARTELILLO=0 THEN
	       KAOS:=TRUE;
	    ELSIF CUARTELILLO=Constant.CUARTELILLO THEN
	       control:=enemy.CrearEnemy(enemigos,pantalla,Constant.EXPLOSION,posx,posy,0,0);
	       DEC(CUARTELILLO);
	    ELSE
	
	       DEC(CUARTELILLO);
	
	    END;
	 ELSIF TIEMPO=0 THEN
	       (*Aki en teoria gana*)
	       control:=BMP.CargaArchivo(youwin,Constant.YOUWIN);
	       control:=BMP.VisBmpMask(youwin,120,75,Constant.MASK);
	       REPEAT
	       UNTIL IO.KeyPressed();
	       KAOS:=TRUE;
	 ELSE
	    avion.Mover(havion,pantalla);
	    avion.Dibujar(havion);
	 END;
	
	
	 avion.Pos(havion,posx,posy);
	 IF Pantalla.HayEnem(pantalla,posx,posy) THEN
	       IF avion.Power(havion)<=Pantalla.Damage(pantalla,posx,posy) THEN
	          avion.InsertaPower(havion,0);
	       ELSE
	         avion.InsertaPower(havion,avion.Power(havion)-Pantalla.Damage(pantalla,posx,posy));
	       END;
	 END;
	 enemy.SiguienteFase(enemigos,pantalla,posx,posy);
	 (*Pantalla.PintaPantalla(pantalla)*); (*(*Este es el encuadrador de enemigos de EMERGENCIA AUUUA AUUUA DA MUEHTE*)*)
	 muehto:=(avion.Power(havion)=0);
	 IF IO.KeyPressed() THEN
	    c:=CAP(IO.RdKey());
	    IO.RdLn;
	    CASE c OF
	         |Constant.ARRIBA:avion.Dir(havion,dirx,diry);
	                          control:=avion.Cambiar_direccion(havion,dirx,diry-1);
	
	         |Constant.ABAJO:avion.Dir(havion,dirx,diry);
	                         control:=avion.Cambiar_direccion(havion,dirx,diry+1);
	
	         |Constant.DERECHA:avion.Dir(havion,dirx,diry);
	                           control:=avion.Cambiar_direccion(havion,dirx+1,diry);
	
	         |Constant.IZQUIERDA:avion.Dir(havion,dirx,diry);
	                             control:=avion.Cambiar_direccion(havion,dirx-1,diry);
	
	    ELSE
	       KAOS:=TRUE;
	    END;
	 END;
	 RETARDODEBUG:=10+10*Constant.MAXNUMENEMIGOSPANT-10*enemy.NumEnemies(enemigos);
	 RETARDO.Retardar(RETARDODEBUG,mul*0.1*REAL(dificultad)); (*Hacemos el retardo*)
	 IF TIEMPO >0 THEN
	    DEC(TIEMPO);
	 END;
	
    UNTIL KAOS;

    avion.Destruir(havion);
    enemy.Destruir(enemigos);
    (*control:=BMP.Destruir(luna);*)
    control:=BMP.Destruir(gameover);
    control:=BMP.Destruir(youwin);
    Pantalla.Destruir(pantalla);
END Suizidar;






(*Programa Principal y tal y cual*)

VAR
  c:CHAR;
  control:INTEGER;

BEGIN
  GRAFIC.ModoGrafico; (*Metemos el modo grafico*)
  MENU.PantallaInicio;
  REPEAT
    c:=MENU.MuestraMenu();
    CASE c OF
           |'1':Inicializar();
                Suizidar();

           |'2':dificultad:=MENU.MenuDificultad(); (*La dificultad es una VAR global, cuidao con el nivel*)
    END;
  UNTIL (c='3'); (*Nos salimossss*)

END SUIZIDER.