IMPLEMENTATION MODULE RETARDO;

IMPORT Lib;

(*
* Esta funcion devuelve el multiplicador que se debe aplicar
* a los retardos para que funcione igual de rapido en
* cualquier maquina.
*)



CONST
  retardo_basico = 1000;



PROCEDURE F_Ret():REAL;


VAR
  hora,minutos,segundos,milesimas:CARDINAL;
  hora2,minutos2,segundos2,milesimas2:CARDINAL;
  multiplicador:REAL;

BEGIN
  multiplicador:=1.0;

  Lib.GetTime(hora,minutos,segundos,milesimas);

  Lib.Delay(retardo_basico);

  Lib.GetTime(hora2,minutos2,segundos2,milesimas2);

  segundos:=segundos MOD 10;
  segundos2:=segundos2 MOD 10;
  IF segundos2=0 THEN
    segundos2:=10;
  END;

  milesimas:=segundos*1000+milesimas;
  milesimas2:=segundos2*1000+milesimas2;

  multiplicador:=1000.0/(REAL(milesimas2-milesimas));

  RETURN multiplicador;

END F_Ret;


PROCEDURE Retardar(ret:CARDINAL;mul:REAL);
  
BEGIN
     
     Lib.Delay(CARDINAL(REAL(ret)*mul));
     
END Retardar;

END RETARDO.
