IMPLEMENTATION MODULE enemy;


IMPORT IO;
FROM Pantalla IMPORT TPantalla;
IMPORT Pantalla;
IMPORT BMP;
FROM Storage IMPORT ALLOCATE,DEALLOCATE,Available;
IMPORT anilldib;
IMPORT Constant;


TYPE
   DESPLAZAMIENTO=RECORD
                      x,y:INTEGER;
                  END;
   VECTOR=RECORD
	       x,y:CARDINAL;
          END;

   POSICION=RECORD
                punto1,punto2:VECTOR;
            END;


   ListaEnem=POINTER TO TListaEnemNodo;
   TListaEnemNodo=RECORD
 	          sig:ListaEnem;
 	          tipo,fase,damage:CARDINAL;
 	          pos:POSICION;
 	          desp:DESPLAZAMIENTO;
 	          dibujos:anilldib.ANILLODIB;
             END;

   TGraficos=ARRAY [0..MAXENEMY-1] OF anilldib.ANILLODIB;

   Tenemy=POINTER TO TEnemNodo;
   TEnemNodo=RECORD
                 graficos:TGraficos;
                 lista:ListaEnem;
             END;


(*ZONA DE PROCEDIMIENTOS*)



PROCEDURE ABS(x:INTEGER):CARDINAL;

VAR
  res:CARDINAL;

BEGIN
    IF x>=0 THEN
       res:=CARDINAL(x);
    ELSE
       res:=CARDINAL((-1)*x);
    END;
    RETURN res
END ABS;



PROCEDURE Inicializar(VAR enemy:Tenemy):INTEGER;

VAR
  res,control:INTEGER;
  i:CARDINAL;
  dibujo:BMP.TBMP;

BEGIN
    IF NOT Available(SIZE(TEnemNodo)) THEN
       res:=-3
    ELSE
       res:=0;
       NEW(enemy);
       enemy^.lista:=NIL;
       (*Aki hace falta llenar con los graficos el array de los enemigos*)
       FOR i:=0 TO MAXENEMY-1 DO
           anilldib.Inicializa(enemy^.graficos[i]);
       END;

       (*Ahora cargamos los graficos correspondientes, esta programacion va a mano*)


       (*Cargamos los graficos del caza americano*)
       control:=BMP.Inicializa(dibujo);
       control:=BMP.CargaArchivo(dibujo,Constant.CAZADIB1);
       IF control<>0 THEN
          RETURN control;
       END;
       control:=anilldib.InsertaAnillo(enemy^.graficos[Constant.CAZA],dibujo);
               IF control<>0 THEN
                  RETURN control;
               END;   
       control:=BMP.Inicializa(dibujo);
       control:=BMP.CargaArchivo(dibujo,Constant.CAZADIB2);
       IF control<>0 THEN
          RETURN control;
       END;
       control:=anilldib.InsertaAnillo(enemy^.graficos[Constant.CAZA],dibujo);
       IF control<>0 THEN
          RETURN control;
       END;
       control:=BMP.Inicializa(dibujo);
       control:=BMP.CargaArchivo(dibujo,Constant.CAZADIB3);
       IF control<>0 THEN
          RETURN control;
       END;
       control:=anilldib.InsertaAnillo(enemy^.graficos[Constant.CAZA],dibujo);
       IF control<>0 THEN
          RETURN control;
       END;
       
       

       (*Cargamos los graficos de la explosion*)
       control:=BMP.Inicializa(dibujo);
       control:=BMP.CargaArchivo(dibujo,Constant.EXPLOSIONDIB1);
       IF control<>0 THEN
          RETURN control;
       END;
       control:=anilldib.InsertaAnillo(enemy^.graficos[Constant.EXPLOSION],dibujo);
               IF control<>0 THEN
                  RETURN control;
               END;
       control:=BMP.Inicializa(dibujo);
       control:=BMP.CargaArchivo(dibujo,Constant.EXPLOSIONDIB2);
       IF control<>0 THEN
          RETURN control;
       END;
       control:=anilldib.InsertaAnillo(enemy^.graficos[Constant.EXPLOSION],dibujo);
               IF control<>0 THEN
                  RETURN control;
               END;
       control:=BMP.Inicializa(dibujo);
       control:=BMP.CargaArchivo(dibujo,Constant.EXPLOSIONDIB3);
       IF control<>0 THEN
          RETURN control;
       END;
       control:=anilldib.InsertaAnillo(enemy^.graficos[Constant.EXPLOSION],dibujo);
               IF control<>0 THEN
                  RETURN control;
               END;
       control:=BMP.Inicializa(dibujo);
       control:=BMP.CargaArchivo(dibujo,Constant.EXPLOSIONDIB4);
       IF control<>0 THEN
          RETURN control;
       END;
       control:=anilldib.InsertaAnillo(enemy^.graficos[Constant.EXPLOSION],dibujo);
               IF control<>0 THEN
                  RETURN control;
               END;
    END;


    (*Cargamos los graficos del harrier*)
       control:=BMP.Inicializa(dibujo);
       control:=BMP.CargaArchivo(dibujo,Constant.HARRIERDIB1);
       IF control<>0 THEN
          RETURN control;
       END;
       control:=anilldib.InsertaAnillo(enemy^.graficos[Constant.HARRIER],dibujo);
               IF control<>0 THEN
                  RETURN control;
               END;
       control:=BMP.Inicializa(dibujo);
       control:=BMP.CargaArchivo(dibujo,Constant.HARRIERDIB2);
       IF control<>0 THEN
          RETURN control;
       END;
       control:=anilldib.InsertaAnillo(enemy^.graficos[Constant.HARRIER],dibujo);
               IF control<>0 THEN
                  RETURN control;
               END;
       control:=BMP.Inicializa(dibujo);
       control:=BMP.CargaArchivo(dibujo,Constant.HARRIERDIB3);
       IF control<>0 THEN
          RETURN control;
       END;
       control:=anilldib.InsertaAnillo(enemy^.graficos[Constant.HARRIER],dibujo);
               IF control<>0 THEN
                  RETURN control;
               END;

       
       
       (*Cargamos los graficos del Morlock*)
       control:=BMP.Inicializa(dibujo);
       control:=BMP.CargaArchivo(dibujo,Constant.MORLOCKDIB1);
       IF control<>0 THEN
          RETURN control;
       END;
       control:=anilldib.InsertaAnillo(enemy^.graficos[Constant.MORLOCK],dibujo);
               IF control<>0 THEN
                  RETURN control;
               END;
       control:=BMP.Inicializa(dibujo);
       control:=BMP.CargaArchivo(dibujo,Constant.MORLOCKDIB2);
       IF control<>0 THEN
          RETURN control;
       END;
       control:=anilldib.InsertaAnillo(enemy^.graficos[Constant.MORLOCK],dibujo);
               IF control<>0 THEN
                  RETURN control;
               END;
       control:=BMP.Inicializa(dibujo);
       control:=BMP.CargaArchivo(dibujo,Constant.MORLOCKDIB3);
       IF control<>0 THEN
          RETURN control;
       END;
       control:=anilldib.InsertaAnillo(enemy^.graficos[Constant.MORLOCK],dibujo);
               IF control<>0 THEN
                  RETURN control;
               END;

    RETURN res;
END Inicializar;


(*Procedimiento para llenar a lo bestia los nodos de enemigo, independientemente de donde se enganchen*)

PROCEDURE LlenaDatosEnem(VAR nodo:TListaEnemNodo;tipo:CARDINAL; VAR pant:TPantalla;x,y:CARDINAL;dx,dy:INTEGER;VAR graficos:TGraficos):INTEGER;

VAR
  res:INTEGER;
  dibujo:BMP.TBMP;
  i:CARDINAL;
  control:INTEGER;
  
BEGIN
    WITH nodo DO
         desp.x:=dx; (*Cargamos los deplazamientos*)
         desp.y:=dy;
         anilldib.Inicializa(dibujos); (*Inicializamos el anillo*)
    END;

    CASE tipo OF
         |0:(*Este tipo es el caza americano*)
          WITH nodo DO
               tipo:=0;
               fase:=0;
               damage:=Constant.CAZADAMAGE;


               (*Ahora cargamos los dibujos*)
		FOR i:=1 TO 3 DO (*Porque hay 3 dibujos*)
		    control:=anilldib.ContAnillo(graficos[0],dibujo);               
                    control:=anilldib.InsertaAnillo(dibujos,dibujo);
                    anilldib.RotaAnillo(graficos[0]);
                    anilldib.RotaAnillo(dibujos);
                END;

               (*Cargamos los puntos de las esquinas*)
               WITH pos DO
               	    punto1.x:=x;
               	    punto1.y:=y;
               	    punto2.x:=x+BMP.Anchura(dibujo)-1;
               	    punto2.y:=y+BMP.Altura(dibujo)-1;
               	    (*Ahora llenamos la pantalla de esos puntos de enemigo maravillosos*)
                    res:=Pantalla.LlenaEnem(pant,punto1.x,punto1.y,punto2.x,punto2.y,damage);
               END;            
          END;
          |1:(*Este tipo es la exlosion de atrezo*)
            WITH nodo DO
               tipo:=1;
               fase:=0;
               damage:=Constant.EXPLOSIONDAMAGE;


               (*Ahora cargamos los dibujos, que estan en graficos[1]*)
		FOR i:=1 TO 4 DO (*Porque hay 3 dibujos*)
		    control:=anilldib.ContAnillo(graficos[1],dibujo);
                    control:=anilldib.InsertaAnillo(dibujos,dibujo);
                    anilldib.RotaAnillo(graficos[1]);
                    anilldib.RotaAnillo(dibujos);
                END;

               (*Cargamos los puntos de las esquinas*)
               WITH pos DO
               	    punto1.x:=x;
               	    punto1.y:=y;
               	    punto2.x:=x+BMP.Anchura(dibujo)-1;
               	    punto2.y:=y+BMP.Altura(dibujo)-1;
               	    (*Ahora llenamos la pantalla de esos puntos de enemigo maravillosos*)
                    (*res:=Pantalla.LlenaEnem(pant,punto1.x,punto1.y,punto2.x,punto2.y,damage); Lo tenemos entre comentarios porque no hace dao*)
                    res:=0;
               END;            
            END;
          |2:(*Este tipo es el harrier que es un avion que se desplaza en zig zag*)
             (*Cuando se crea este enemigo el vector de direccion se inicializa con*)
             
          WITH nodo DO
               tipo:=2;
               fase:=0;
               damage:=Constant.HARRIERDAMAGE;


               (*Ahora cargamos los dibujos*)
		FOR i:=1 TO 3 DO (*Porque hay 3 dibujos*)
		    control:=anilldib.ContAnillo(graficos[Constant.HARRIER],dibujo);               
                    control:=anilldib.InsertaAnillo(dibujos,dibujo);
                    anilldib.RotaAnillo(graficos[Constant.HARRIER]);
                    anilldib.RotaAnillo(dibujos);
                END;

               (*Cargamos los puntos de las esquinas*)
               WITH pos DO
               	    punto1.x:=x;
               	    punto1.y:=y;
               	    punto2.x:=x+BMP.Anchura(dibujo)-1;
               	    punto2.y:=y+BMP.Altura(dibujo)-1;
               	    (*Ahora llenamos la pantalla de esos puntos de enemigo maravillosos*)
                    res:=Pantalla.LlenaEnem(pant,punto1.x,punto1.y,punto2.x,punto2.y,damage);
               END;            
          END;
          
          |3:(*Este tipo es el morlock que es un avion que se desplaza en zig zag*)
             (*Cuando se crea este enemigo el vector de direccion se inicializa con*)

          WITH nodo DO
               tipo:=2;
               fase:=0;
               damage:=Constant.MORLOCKDAMAGE;


               (*Ahora cargamos los dibujos*)
		FOR i:=1 TO 3 DO (*Porque hay 3 dibujos*)
		    control:=anilldib.ContAnillo(graficos[Constant.MORLOCK],dibujo);               
                    control:=anilldib.InsertaAnillo(dibujos,dibujo);
                    anilldib.RotaAnillo(graficos[Constant.MORLOCK]);
                    anilldib.RotaAnillo(dibujos);
                END;

               (*Cargamos los puntos de las esquinas*)
               WITH pos DO
               	    punto1.x:=x;
               	    punto1.y:=y;
               	    punto2.x:=x+BMP.Anchura(dibujo)-1;
               	    punto2.y:=y+BMP.Altura(dibujo)-1;
               	    (*Ahora llenamos la pantalla de esos puntos de enemigo maravillosos*)
                    res:=Pantalla.LlenaEnem(pant,punto1.x,punto1.y,punto2.x,punto2.y,damage);
               END;
          END;
          (*Aki estamos preparados para aadir mas enemigos*)
    ELSE
       res:=-2;
    END;
    RETURN res
END LlenaDatosEnem;



PROCEDURE DibujaEnem(enemy:ListaEnem);

    PROCEDURE DibujaNodo(VAR nodo:TListaEnemNodo);
     VAR
        dibujo:BMP.TBMP;
        control:INTEGER;

     BEGIN
        control:=BMP.Inicializa(dibujo);
        control:=anilldib.ContAnillo(nodo.dibujos,dibujo);
        control:=BMP.VisBmpMask(dibujo,nodo.pos.punto1.x,nodo.pos.punto1.y,Constant.MASK);
    END DibujaNodo;

BEGIN
    IF enemy<>NIL THEN
       DibujaNodo(enemy^);
       DibujaEnem(enemy^.sig);
    END;

END DibujaEnem;



PROCEDURE CrearEnemy(VAR enemy:Tenemy;VAR pantalla:TPantalla;tipo:CARDINAL;x,y:CARDINAL;dx,dy:INTEGER):INTEGER;

VAR
  res:INTEGER;
  nuevonodo:ListaEnem;

BEGIN
    IF NOT Available(SIZE(TListaEnemNodo)) THEN (*No tenemos memoria*)
       res:=-3;
    ELSE (*Tenemos memoria*)
       NEW(nuevonodo);
       res:=LlenaDatosEnem(nuevonodo^,tipo,pantalla,x,y,dx,dy,enemy^.graficos); (*Usamos esta funcion para llenar el nodo con los datos y clarificar la cosa*)
       IF res=0 THEN (*se ha asignado de manera correcta, por lo que insertamos por el principio*)
          nuevonodo^.sig:=enemy^.lista;
          enemy^.lista:=nuevonodo;
       END;
    END;

    RETURN res
END CrearEnemy;





PROCEDURE Destruir(VAR enemy:Tenemy);

     PROCEDURE DestruirListaEnem(VAR enemy:ListaEnem);

      BEGIN
    	IF enemy<>NIL THEN
           anilldib.EliminaAnillo(enemy^.dibujos);
           DestruirListaEnem(enemy^.sig);
           DISPOSE(enemy);
        END;
     END DestruirListaEnem;

VAR
  i:CARDINAL;


BEGIN
    IF enemy<>NIL THEN (*La cosa no esta vacia*)
       DestruirListaEnem(enemy^.lista);
       FOR i:=0 TO MAXENEMY-1 DO
           anilldib.Destruye(enemy^.graficos[i]); (*Esto se lo carga todo, incluidos los dibujos*)
       END;
    END;

END Destruir;



(*Ahora viene el procedimiento estrella de este modulo, un procedimiento que indica la siguiente fase de todos los enemigos a la vez*)


PROCEDURE SiguienteFase(VAR enemy:Tenemy;VAR pantalla:TPantalla; x,y:CARDINAL);

(*Zona de procedimientos suplementarios*)

  

  PROCEDURE PurgaDestruidos(VAR enemy:Tenemy; VAR pantalla:TPantalla;x,y:CARDINAL):INTEGER;
      
      PROCEDURE DestruyeNodo(VAR enemy:ListaEnem;punt:ListaEnem); (*Se carga un nodo de la lista*)
   	  VAR
   	    temp:ListaEnem;
   	BEGIN
   	     IF enemy<>NIL THEN
   	        anilldib.EliminaAnillo(punt^.dibujos); (*Nos cargamos la lista de dibujitos*)
   	        IF punt=enemy THEN (*Tenemos que seccionar la cabeza*)
   	           temp:=enemy;
   	           enemy:=enemy^.sig;
   	           anilldib.EliminaAnillo(temp^.dibujos);
   	           DISPOSE(temp);
   	        ELSE (*El nodo no esta en la cabeza*)
   	           temp:=enemy;
   	           WHILE (temp<>NIL) AND (temp^.sig<>punt) DO
   	               temp:=temp^.sig;
   	           END;
   	           IF temp^.sig=punt THEN
   	              temp^.sig:=punt^.sig;
   	              anilldib.EliminaAnillo(punt^.dibujos); (*Nos cargamos la lista de dibujitos*)
   	              DISPOSE(punt);
   	           END;
   	        END;
   	     END;
   	
   	END DestruyeNodo;
    
      	

   VAR
     temp,punt:ListaEnem;
     control:INTEGER;
   BEGIN
      control:=0;
      IF enemy<>NIL THEN (*Comprobamos que la lista no este vacia*)
        IF enemy^.lista<>NIL THEN
         punt:=enemy^.lista;
         WHILE punt<>NIL DO
               temp:=punt^.sig;
               WITH punt^ DO
                    (*Ahora tenemos que enumerar las razones de destruir a un enemigo*)
                    IF ((pos.punto1.x<=x) AND (pos.punto2.x>=x) AND (pos.punto1.y<=y) AND (pos.punto2.y>=y)) THEN (*Colision frontal con un enemigo*)
                       control:=CrearEnemy(enemy,pantalla,Constant.EXPLOSION,pos.punto1.x,pos.punto2.y,-2,0); (*Creamos la explosion*)
                       DestruyeNodo(enemy^.lista,punt); (*Destruye el nodo de la lista de enemigos*)
                    ELSIF ((pos.punto1.x<=ABS(desp.x)) OR (pos.punto2.x+ABS(desp.x)>=Constant.MAXPANTALLAX) OR (pos.punto1.y<=ABS(desp.y)) OR (pos.punto2.y+ABS(desp.y)>=Constant.MAXPANTALLAY)) THEN (*Enemigo que se sale de la pantalla*)
                        DestruyeNodo(enemy^.lista,punt); (*Destruye el nodo de la lista de enemigos*);
                        control:=Pantalla.VaciaEnem(pantalla,pos.punto1.x,pos.punto1.y,pos.punto2.x,pos.punto2.y); (*Limpiamos la pantalla del dao de ese enemigo*)
                    ELSIF (tipo=1) AND (fase=3) THEN (*Explosion en su ultima fase*)
                       DestruyeNodo(enemy^.lista,punt); (*Destruye el nodo de la lista de enemigos*)
                    END;
               END;
               punt:=temp;
         END;
       END;
      END;
      RETURN control;
  END PurgaDestruidos;


  PROCEDURE FaseaLista(VAR enemy:ListaEnem;VAR pantalla:TPantalla);


   PROCEDURE ActualizaNodo(VAR nodo:TListaEnemNodo);

    VAR

    BEGIN
        WITH nodo DO
             CASE tipo OF
                  |0:(*Esta es la actualizacion del caza americano*)
                      fase:=(fase+1) MOD Constant.CAZANUMFASES; (*Le subimos la fase, aqui no vale para nada pero bueno...*)
                      anilldib.RotaAnillo(dibujos); (*Para que se vea el siguiente sprite*)
             	      pos.punto1.x:=CARDINAL(INTEGER(pos.punto1.x)+desp.x); (*Sumamos los deplazamientos a las coordenadas de posicion*)
             	      pos.punto2.x:=CARDINAL(INTEGER(pos.punto2.x)+desp.x);
             	      pos.punto1.y:=CARDINAL(INTEGER(pos.punto1.y)+desp.y);
             	      pos.punto2.y:=CARDINAL(INTEGER(pos.punto2.y)+desp.y);
             	   |1:(*Esta es la actualizacion de la explosion*)
             	      fase:=(fase+1) MOD Constant.EXPNUMFASES; (*Le subimos la fase, aqui no vale para nada pero bueno...*)
                      anilldib.RotaAnillo(dibujos); (*Para que se vea el siguiente sprite*)
             	      pos.punto1.x:=CARDINAL(INTEGER(pos.punto1.x)+desp.x); (*Sumamos los deplazamientos a las coordenadas de posicion*)
             	      pos.punto2.x:=CARDINAL(INTEGER(pos.punto2.x)+desp.x);
             	      pos.punto1.y:=CARDINAL(INTEGER(pos.punto1.y)+desp.y);
             	      pos.punto2.y:=CARDINAL(INTEGER(pos.punto2.y)+desp.y);
             	   |2:(*Esta es la actualizacion del harrier*) 
                      anilldib.RotaAnillo(dibujos); (*Para que se vea el siguiente sprite*)
             	      pos.punto1.x:=CARDINAL(INTEGER(pos.punto1.x)+desp.x); (*Sumamos los deplazamientos a las coordenadas de posicion*)
             	      pos.punto2.x:=CARDINAL(INTEGER(pos.punto2.x)+desp.x);
             	      IF fase<3 THEN
             	         pos.punto1.y:=CARDINAL(INTEGER(pos.punto1.y)+desp.y);
             	         pos.punto2.y:=CARDINAL(INTEGER(pos.punto2.y)+desp.y); 
             	      ELSE
             	         pos.punto1.y:=CARDINAL(INTEGER(pos.punto1.y)-desp.y);
             	         pos.punto2.y:=CARDINAL(INTEGER(pos.punto2.y)-desp.y); 
             	      END;
             	      fase:=(fase+1) MOD Constant.HARRIERNUMFASES; (*Ahora la fase es muy importante porque en la 3 cambiara de direccion*)  
                    |3:(*Esta es la actualizacion del morlock*) 
                      anilldib.RotaAnillo(dibujos); (*Para que se vea el siguiente sprite*)
             	      pos.punto1.x:=CARDINAL(INTEGER(pos.punto1.x)+desp.x); (*Sumamos los deplazamientos a las coordenadas de posicion*)
             	      pos.punto2.x:=CARDINAL(INTEGER(pos.punto2.x)+desp.x);
             	      IF fase<3 THEN
             	         pos.punto1.y:=CARDINAL(INTEGER(pos.punto1.y)+desp.y);
             	         pos.punto2.y:=CARDINAL(INTEGER(pos.punto2.y)+desp.y); 
             	      ELSE
             	         pos.punto1.y:=CARDINAL(INTEGER(pos.punto1.y)-desp.y);
             	         pos.punto2.y:=CARDINAL(INTEGER(pos.punto2.y)-desp.y); 
             	      END;
             	      fase:=(fase+1) MOD Constant.MORLOCKNUMFASES; (*Ahora la fase es muy importante porque en la 3 cambiara de direccion*)
             ELSE
	        (*Na de na, las 4 de la maana no es hora de programar  ooo jojojojooo*)
             END;
        END;
   END ActualizaNodo;



   VAR
     punt:ListaEnem;
     control:INTEGER;

   BEGIN
      IF enemy<>NIL THEN
         punt:=enemy;
         WHILE punt<>NIL DO
               (*control:=Pantalla.VaciaEnem(pantalla,punt^.pos.punto1.x,punt^.pos.punto1.y,punt^.pos.punto2.x,punt^.pos.punto2.y); (*Borramos el area del enemigo que dejaba en pantalla*)*)
               ActualizaNodo(punt^);
               control:=Pantalla.LlenaEnem(pantalla,punt^.pos.punto1.x,punt^.pos.punto1.y,punt^.pos.punto2.x,punt^.pos.punto2.y,punt^.damage); (*Llenamos de puntos hostiles la zona actualizada donde se encuentra el enemigo*)
               punt:=punt^.sig;
         END;
      END;
  END FaseaLista;



(*Fin de la zona de procedimientos suplementarios*)

VAR
  control:INTEGER;

BEGIN
   IF enemy<>NIL THEN (*Comprobamos que no esta vacio*)
      control:=PurgaDestruidos(enemy,pantalla,x,y); (*Purgamos los que en la fase anterior estan fuera de rango o han chocado, por eso le metemos el parametro de la posicion actual del avion*)
      DibujaEnem(enemy^.lista); (*Dibujamos la fase anterior*)
      Pantalla.Destruir(pantalla);
      FaseaLista(enemy^.lista,pantalla); (*Cambia de fase a todos los nodos aunque los resultados sean absurdos, de eso se encargara la purga*)
   END;

END SiguienteFase;


PROCEDURE NumEnemies(enemy:Tenemy):CARDINAL;

   PROCEDURE NumNodosListaEnemies(lista:ListaEnem):CARDINAL;
      VAR
        res:CARDINAL;
   BEGIN
       IF lista<>NIL THEN
          res:=1+NumNodosListaEnemies(lista^.sig);
       ELSE
          res:=0
       END;
         RETURN res
   END NumNodosListaEnemies;

BEGIN
    RETURN NumNodosListaEnemies(enemy^.lista);

END NumEnemies;

END enemy.